<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>Quaternions (Rotations)</title>
<meta name="generator" content="DocBook XSL Stylesheets V1.78.1">
<link rel="home" href="index.html" title="Cogl 2.0 Reference Manual">
<link rel="up" href="cogl-utilities.html" title="Utilities">
<link rel="prev" href="cogl-2.0-experimental-Eulers-(Rotations).html" title="Eulers (Rotations)">
<link rel="next" href="cogl-2.0-experimental-GPU-synchronisation-fences.html" title="GPU synchronisation fences">
<meta name="generator" content="GTK-Doc V1.18.1 (XML mode)">
<link rel="stylesheet" href="style.css" type="text/css">
</head>
<body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF">
<table class="navigation" id="top" width="100%" summary="Navigation header" cellpadding="2" cellspacing="2">
<tr valign="middle">
<td><a accesskey="p" href="cogl-2.0-experimental-Eulers-(Rotations).html"><img src="left.png" width="24" height="24" border="0" alt="Prev"></a></td>
<td><a accesskey="u" href="cogl-utilities.html"><img src="up.png" width="24" height="24" border="0" alt="Up"></a></td>
<td><a accesskey="h" href="index.html"><img src="home.png" width="24" height="24" border="0" alt="Home"></a></td>
<th width="100%" align="center">Cogl 2.0 Reference Manual</th>
<td><a accesskey="n" href="cogl-2.0-experimental-GPU-synchronisation-fences.html"><img src="right.png" width="24" height="24" border="0" alt="Next"></a></td>
</tr>
<tr><td colspan="5" class="shortcuts">
<a href="#cogl-2.0-experimental-Quaternions-(Rotations).synopsis" class="shortcut">Top</a>
                   | 
                  <a href="#cogl-2.0-experimental-Quaternions-(Rotations).description" class="shortcut">Description</a>
</td></tr>
</table>
<div class="refentry">
<a name="cogl-2.0-experimental-Quaternions-(Rotations)"></a><div class="titlepage"></div>
<div class="refnamediv"><table width="100%"><tr>
<td valign="top">
<h2><span class="refentrytitle"><a name="cogl-2.0-experimental-Quaternions-(Rotations).top_of_page"></a>Quaternions (Rotations)</span></h2>
<p>Quaternions (Rotations) — Functions for initializing and manipulating
quaternions.</p>
</td>
<td valign="top" align="right"></td>
</tr></table></div>
<div class="refsynopsisdiv">
<a name="cogl-2.0-experimental-Quaternions-(Rotations).synopsis"></a><h2>Synopsis</h2>
<pre class="synopsis">                    <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion">CoglQuaternion</a>;
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#cogl-quaternion-init-identity" title="cogl_quaternion_init_identity ()">cogl_quaternion_init_identity</a>       (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *quaternion</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#cogl-quaternion-init" title="cogl_quaternion_init ()">cogl_quaternion_init</a>                (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *quaternion</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> angle</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> x</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> y</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> z</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#cogl-quaternion-init-from-quaternion" title="cogl_quaternion_init_from_quaternion ()">cogl_quaternion_init_from_quaternion</a>
                                                        (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *quaternion</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *src</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#cogl-quaternion-init-from-angle-vector" title="cogl_quaternion_init_from_angle_vector ()">cogl_quaternion_init_from_angle_vector</a>
                                                        (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *quaternion</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> angle</code></em>,
                                                         <em class="parameter"><code>const <span class="type">float</span> *axis3f</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#cogl-quaternion-init-from-array" title="cogl_quaternion_init_from_array ()">cogl_quaternion_init_from_array</a>     (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *quaternion</code></em>,
                                                         <em class="parameter"><code>const <span class="type">float</span> *array</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#cogl-quaternion-init-from-x-rotation" title="cogl_quaternion_init_from_x_rotation ()">cogl_quaternion_init_from_x_rotation</a>
                                                        (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *quaternion</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> angle</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#cogl-quaternion-init-from-y-rotation" title="cogl_quaternion_init_from_y_rotation ()">cogl_quaternion_init_from_y_rotation</a>
                                                        (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *quaternion</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> angle</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#cogl-quaternion-init-from-z-rotation" title="cogl_quaternion_init_from_z_rotation ()">cogl_quaternion_init_from_z_rotation</a>
                                                        (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *quaternion</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> angle</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#cogl-quaternion-init-from-euler" title="cogl_quaternion_init_from_euler ()">cogl_quaternion_init_from_euler</a>     (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *quaternion</code></em>,
                                                         <em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Eulers-(Rotations).html#CoglEuler" title="CoglEuler"><span class="type">CoglEuler</span></a> *euler</code></em>);
<a class="link" href="cogl-2.0-experimental-Common-Types.html#CoglBool" title="CoglBool"><span class="returnvalue">CoglBool</span></a>            <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#cogl-quaternion-equal" title="cogl_quaternion_equal ()">cogl_quaternion_equal</a>               (<em class="parameter"><code>const <span class="type">void</span> *v1</code></em>,
                                                         <em class="parameter"><code>const <span class="type">void</span> *v2</code></em>);
<a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="returnvalue">CoglQuaternion</span></a> *    <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#cogl-quaternion-copy" title="cogl_quaternion_copy ()">cogl_quaternion_copy</a>                (<em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *src</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#cogl-quaternion-free" title="cogl_quaternion_free ()">cogl_quaternion_free</a>                (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *quaternion</code></em>);
<span class="returnvalue">float</span>               <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#cogl-quaternion-get-rotation-angle" title="cogl_quaternion_get_rotation_angle ()">cogl_quaternion_get_rotation_angle</a>  (<em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *quaternion</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#cogl-quaternion-get-rotation-axis" title="cogl_quaternion_get_rotation_axis ()">cogl_quaternion_get_rotation_axis</a>   (<em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *quaternion</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> *vector3</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#cogl-quaternion-normalize" title="cogl_quaternion_normalize ()">cogl_quaternion_normalize</a>           (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *quaternion</code></em>);
<span class="returnvalue">float</span>               <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#cogl-quaternion-dot-product" title="cogl_quaternion_dot_product ()">cogl_quaternion_dot_product</a>         (<em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *a</code></em>,
                                                         <em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *b</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#cogl-quaternion-invert" title="cogl_quaternion_invert ()">cogl_quaternion_invert</a>              (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *quaternion</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#cogl-quaternion-multiply" title="cogl_quaternion_multiply ()">cogl_quaternion_multiply</a>            (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *result</code></em>,
                                                         <em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *left</code></em>,
                                                         <em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *right</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#cogl-quaternion-pow" title="cogl_quaternion_pow ()">cogl_quaternion_pow</a>                 (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *quaternion</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> exponent</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#cogl-quaternion-slerp" title="cogl_quaternion_slerp ()">cogl_quaternion_slerp</a>               (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *result</code></em>,
                                                         <em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *a</code></em>,
                                                         <em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *b</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> t</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#cogl-quaternion-nlerp" title="cogl_quaternion_nlerp ()">cogl_quaternion_nlerp</a>               (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *result</code></em>,
                                                         <em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *a</code></em>,
                                                         <em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *b</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> t</code></em>);
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#cogl-quaternion-squad" title="cogl_quaternion_squad ()">cogl_quaternion_squad</a>               (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *result</code></em>,
                                                         <em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *prev</code></em>,
                                                         <em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *a</code></em>,
                                                         <em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *b</code></em>,
                                                         <em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *next</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> t</code></em>);
const <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="returnvalue">CoglQuaternion</span></a> * <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#cogl-get-static-identity-quaternion" title="cogl_get_static_identity_quaternion ()">cogl_get_static_identity_quaternion</a>
                                                        (<em class="parameter"><code><span class="type">void</span></code></em>);
const <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="returnvalue">CoglQuaternion</span></a> * <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#cogl-get-static-zero-quaternion" title="cogl_get_static_zero_quaternion ()">cogl_get_static_zero_quaternion</a>  (<em class="parameter"><code><span class="type">void</span></code></em>);
</pre>
</div>
<div class="refsect1">
<a name="cogl-2.0-experimental-Quaternions-(Rotations).description"></a><h2>Description</h2>
<p>
Quaternions have become a standard form for representing 3D
rotations and have some nice properties when compared with other
representation such as (roll,pitch,yaw) Euler angles. They can be
used to interpolate between different rotations and they don't
suffer from a problem called
<a class="ulink" href="http://en.wikipedia.org/wiki/Gimbal_lock" target="_top">"Gimbal lock"</a>
where two of the axis of rotation may become aligned and you loose a
degree of freedom.
.
</p>
</div>
<div class="refsect1">
<a name="cogl-2.0-experimental-Quaternions-(Rotations).details"></a><h2>Details</h2>
<div class="refsect2">
<a name="CoglQuaternion"></a><h3>CoglQuaternion</h3>
<pre class="programlisting">typedef struct {
  float w;

  float x;
  float y;
  float z;
} CoglQuaternion;
</pre>
<p>
A quaternion is comprised of a scalar component and a 3D vector
component. The scalar component is normally referred to as w and the
vector might either be referred to as v or a (for axis) or expanded
with the individual components: (x, y, z) A full quaternion would
then be written as <code class="literal">[w (x, y, z)]</code>.
</p>
<p>
Quaternions can be considered to represent an axis and angle
pair although sadly these numbers are buried somewhat under some
maths...
</p>
<p>
For the curious you can see here that a given axis (a) and angle (𝜃)
pair are represented in a quaternion as follows:
</p>
<div class="informalexample">
  <table class="listing_frame" border="0" cellpadding="0" cellspacing="0">
    <tbody>
      <tr>
        <td class="listing_lines" align="right"><pre>1</pre></td>
        <td class="listing_code"><pre class="programlisting"><span class="symbol">[</span><span class="normal">w</span><span class="symbol">=</span><span class="function">cos</span><span class="symbol">(</span><span class="normal">𝜃</span><span class="symbol">/</span><span class="number">2</span><span class="symbol">)</span><span class="normal"> </span><span class="symbol">(</span><span class="normal"> x</span><span class="symbol">=</span><span class="function">sin</span><span class="symbol">(</span><span class="normal">𝜃</span><span class="symbol">/</span><span class="number">2</span><span class="symbol">)*</span><span class="normal">a</span><span class="symbol">.</span><span class="normal">x</span><span class="symbol">,</span><span class="normal"> y</span><span class="symbol">=</span><span class="function">sin</span><span class="symbol">(</span><span class="normal">𝜃</span><span class="symbol">/</span><span class="number">2</span><span class="symbol">)*</span><span class="normal">a</span><span class="symbol">.</span><span class="normal">y</span><span class="symbol">,</span><span class="normal"> z</span><span class="symbol">=</span><span class="function">sin</span><span class="symbol">(</span><span class="normal">𝜃</span><span class="symbol">/</span><span class="number">2</span><span class="symbol">)*</span><span class="normal">a</span><span class="symbol">.</span><span class="normal">x </span><span class="symbol">)]</span></pre></td>
      </tr>
    </tbody>
  </table>
</div>

<p>
</p>
<p>
Unit Quaternions:
When using Quaternions to represent spatial orientations for 3D
graphics it's always assumed you have a unit quaternion. The
magnitude of a quaternion is defined as:
</p>
<div class="informalexample">
  <table class="listing_frame" border="0" cellpadding="0" cellspacing="0">
    <tbody>
      <tr>
        <td class="listing_lines" align="right"><pre>1</pre></td>
        <td class="listing_code"><pre class="programlisting"><span class="function">sqrt</span><span class="normal"> </span><span class="symbol">(</span><span class="normal">w² </span><span class="symbol">+</span><span class="normal"> x² </span><span class="symbol">+</span><span class="normal"> y² </span><span class="symbol">+</span><span class="normal"> z²</span><span class="symbol">)</span></pre></td>
      </tr>
    </tbody>
  </table>
</div>

<p>
and a unit quaternion satisfies this equation:
</p>
<div class="informalexample">
  <table class="listing_frame" border="0" cellpadding="0" cellspacing="0">
    <tbody>
      <tr>
        <td class="listing_lines" align="right"><pre>1</pre></td>
        <td class="listing_code"><pre class="programlisting"><span class="normal">w² </span><span class="symbol">+</span><span class="normal"> x² </span><span class="symbol">+</span><span class="normal"> y² </span><span class="symbol">+</span><span class="normal"> z² </span><span class="symbol">=</span><span class="normal"> </span><span class="number">1</span></pre></td>
      </tr>
    </tbody>
  </table>
</div>

<p>
</p>
<p>
Thankfully most of the time we don't actually have to worry about
the maths that goes on behind the scenes but if you are curious to
learn more here are some external references:
</p>
<p>
</p>
<div class="itemizedlist"><ul class="itemizedlist" style="list-style-type: disc; ">
<li class="listitem"><a class="ulink" href="http://mathworld.wolfram.com/Quaternion.html" target="_top">http://mathworld.wolfram.com/Quaternion.html</a></li>
<li class="listitem"><a class="ulink" href="http://www.gamedev.net/reference/articles/article1095.asp" target="_top">http://www.gamedev.net/reference/articles/article1095.asp</a></li>
<li class="listitem"><a class="ulink" href="http://www.cprogramming.com/tutorial/3d/quaternions.html" target="_top">http://www.cprogramming.com/tutorial/3d/quaternions.html</a></li>
<li class="listitem"><a class="ulink" href="http://www.isner.com/tutorials/quatSpells/quaternion_spells_12.htm" target="_top">http://www.isner.com/tutorials/quatSpells/quaternion_spells_12.htm</a></li>
<li class="listitem">
3D Maths Primer for Graphics and Game Development ISBN-10: 1556229119
</li>
<li class="listitem"><a class="ulink" href="http://www.cs.caltech.edu/courses/cs171/quatut.pdf" target="_top">http://www.cs.caltech.edu/courses/cs171/quatut.pdf</a></li>
<li class="listitem"><a class="ulink" href="http://www.j3d.org/matrix_faq/matrfaq_latest.html#Q56" target="_top">http://www.j3d.org/matrix_faq/matrfaq_latest.html#Q56</a></li>
</ul></div>
<p>
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><span class="type">float</span> <em class="structfield"><code><a name="CoglQuaternion.w"></a>w</code></em>;</span></p></td>
<td>based on the angle of rotation it is cos(𝜃/2)</td>
</tr>
<tr>
<td><p><span class="term"><span class="type">float</span> <em class="structfield"><code><a name="CoglQuaternion.x"></a>x</code></em>;</span></p></td>
<td>based on the angle of rotation and x component of the axis of
rotation it is sin(𝜃/2)*axis.x</td>
</tr>
<tr>
<td><p><span class="term"><span class="type">float</span> <em class="structfield"><code><a name="CoglQuaternion.y"></a>y</code></em>;</span></p></td>
<td>based on the angle of rotation and y component of the axis of
rotation it is sin(𝜃/2)*axis.y</td>
</tr>
<tr>
<td><p><span class="term"><span class="type">float</span> <em class="structfield"><code><a name="CoglQuaternion.z"></a>z</code></em>;</span></p></td>
<td>based on the angle of rotation and z component of the axis of
rotation it is sin(𝜃/2)*axis.z</td>
</tr>
</tbody>
</table></div>
</div>
<hr>
<div class="refsect2">
<a name="cogl-quaternion-init-identity"></a><h3>cogl_quaternion_init_identity ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_quaternion_init_identity       (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *quaternion</code></em>);</pre>
<p>
Initializes the quaternion with the canonical quaternion identity
[1 (0, 0, 0)] which represents no rotation. Multiplying a
quaternion with this identity leaves the quaternion unchanged.
</p>
<p>
You might also want to consider using
<a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#cogl-get-static-identity-quaternion" title="cogl_get_static_identity_quaternion ()"><code class="function">cogl_get_static_identity_quaternion()</code></a>.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody><tr>
<td><p><span class="term"><em class="parameter"><code>quaternion</code></em> :</span></p></td>
<td>An uninitialized <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a>
</td>
</tr></tbody>
</table></div>
<p class="since">Since 2.0</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-quaternion-init"></a><h3>cogl_quaternion_init ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_quaternion_init                (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *quaternion</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> angle</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> x</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> y</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> z</code></em>);</pre>
<p>
Initializes a quaternion that rotates <em class="parameter"><code>angle</code></em> degrees around the
axis vector (<em class="parameter"><code>x</code></em>, <em class="parameter"><code>y</code></em>, <em class="parameter"><code>z</code></em>). The axis vector does not need to be
normalized.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>quaternion</code></em> :</span></p></td>
<td>An uninitialized <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>angle</code></em> :</span></p></td>
<td>The angle you want to rotate around the given axis</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>x</code></em> :</span></p></td>
<td>The x component of your axis vector about which you want to
rotate.</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>y</code></em> :</span></p></td>
<td>The y component of your axis vector about which you want to
rotate.</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>z</code></em> :</span></p></td>
<td>The z component of your axis vector about which you want to
rotate.</td>
</tr>
<tr>
<td><p><span class="term"><span class="emphasis"><em>Returns</em></span> :</span></p></td>
<td>A normalized, unit quaternion representing an orientation
rotated <em class="parameter"><code>angle</code></em> degrees around the axis vector (<em class="parameter"><code>x</code></em>, <em class="parameter"><code>y</code></em>, <em class="parameter"><code>z</code></em>)</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 2.0</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-quaternion-init-from-quaternion"></a><h3>cogl_quaternion_init_from_quaternion ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_quaternion_init_from_quaternion
                                                        (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *quaternion</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *src</code></em>);</pre>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>quaternion</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>src</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> with which to initialize <em class="parameter"><code>quaternion</code></em>
</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 2.0</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-quaternion-init-from-angle-vector"></a><h3>cogl_quaternion_init_from_angle_vector ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_quaternion_init_from_angle_vector
                                                        (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *quaternion</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> angle</code></em>,
                                                         <em class="parameter"><code>const <span class="type">float</span> *axis3f</code></em>);</pre>
<p>
Initializes a quaternion that rotates <em class="parameter"><code>angle</code></em> degrees around the
given <em class="parameter"><code>axis</code></em> vector. The axis vector does not need to be
normalized.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>quaternion</code></em> :</span></p></td>
<td>An uninitialized <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>angle</code></em> :</span></p></td>
<td>The angle to rotate around <em class="parameter"><code>axis3f</code></em>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>axis3f</code></em> :</span></p></td>
<td>your 3 component axis vector about which you want to rotate.</td>
</tr>
<tr>
<td><p><span class="term"><span class="emphasis"><em>Returns</em></span> :</span></p></td>
<td>A normalized, unit quaternion representing an orientation
rotated <em class="parameter"><code>angle</code></em> degrees around the given <em class="parameter"><code>axis</code></em> vector.</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 2.0</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-quaternion-init-from-array"></a><h3>cogl_quaternion_init_from_array ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_quaternion_init_from_array     (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *quaternion</code></em>,
                                                         <em class="parameter"><code>const <span class="type">float</span> *array</code></em>);</pre>
<p>
Initializes a [w (x, y,z)] quaternion directly from an array of 4
floats: [w,x,y,z].
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>quaternion</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>array</code></em> :</span></p></td>
<td>An array of 4 floats w,(x,y,z)</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 2.0</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-quaternion-init-from-x-rotation"></a><h3>cogl_quaternion_init_from_x_rotation ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_quaternion_init_from_x_rotation
                                                        (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *quaternion</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> angle</code></em>);</pre>
<p>
XXX: check which direction this rotates
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>quaternion</code></em> :</span></p></td>
<td>An uninitialized <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>angle</code></em> :</span></p></td>
<td>The angle to rotate around the x axis</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 2.0</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-quaternion-init-from-y-rotation"></a><h3>cogl_quaternion_init_from_y_rotation ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_quaternion_init_from_y_rotation
                                                        (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *quaternion</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> angle</code></em>);</pre>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>quaternion</code></em> :</span></p></td>
<td>An uninitialized <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>angle</code></em> :</span></p></td>
<td>The angle to rotate around the y axis</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 2.0</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-quaternion-init-from-z-rotation"></a><h3>cogl_quaternion_init_from_z_rotation ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_quaternion_init_from_z_rotation
                                                        (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *quaternion</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> angle</code></em>);</pre>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>quaternion</code></em> :</span></p></td>
<td>An uninitialized <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>angle</code></em> :</span></p></td>
<td>The angle to rotate around the z axis</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 2.0</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-quaternion-init-from-euler"></a><h3>cogl_quaternion_init_from_euler ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_quaternion_init_from_euler     (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *quaternion</code></em>,
                                                         <em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Eulers-(Rotations).html#CoglEuler" title="CoglEuler"><span class="type">CoglEuler</span></a> *euler</code></em>);</pre>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>quaternion</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>euler</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-Eulers-(Rotations).html#CoglEuler" title="CoglEuler"><span class="type">CoglEuler</span></a> with which to initialize the quaternion</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 2.0</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-quaternion-equal"></a><h3>cogl_quaternion_equal ()</h3>
<pre class="programlisting"><a class="link" href="cogl-2.0-experimental-Common-Types.html#CoglBool" title="CoglBool"><span class="returnvalue">CoglBool</span></a>            cogl_quaternion_equal               (<em class="parameter"><code>const <span class="type">void</span> *v1</code></em>,
                                                         <em class="parameter"><code>const <span class="type">void</span> *v2</code></em>);</pre>
<p>
Compares that all the components of quaternions <em class="parameter"><code>a</code></em> and <em class="parameter"><code>b</code></em> are
equal.
</p>
<p>
An epsilon value is not used to compare the float components, but
the == operator is at least used so that 0 and -0 are considered
equal.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>v1</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>v2</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a>
</td>
</tr>
<tr>
<td><p><span class="term"><span class="emphasis"><em>Returns</em></span> :</span></p></td>
<td>
<a href="http://library.gnome.org/devel/glib/unstable/glib-Standard-Macros.html#TRUE:CAPS"><code class="literal">TRUE</code></a> if the quaternions are equal else <a href="http://library.gnome.org/devel/glib/unstable/glib-Standard-Macros.html#FALSE:CAPS"><code class="literal">FALSE</code></a>.</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 2.0</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-quaternion-copy"></a><h3>cogl_quaternion_copy ()</h3>
<pre class="programlisting"><a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="returnvalue">CoglQuaternion</span></a> *    cogl_quaternion_copy                (<em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *src</code></em>);</pre>
<p>
Allocates a new <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> on the stack and initializes it with
the same values as <em class="parameter"><code>src</code></em>.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>src</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a>
</td>
</tr>
<tr>
<td><p><span class="term"><span class="emphasis"><em>Returns</em></span> :</span></p></td>
<td>A newly allocated <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> which should be freed
using <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#cogl-quaternion-free" title="cogl_quaternion_free ()"><code class="function">cogl_quaternion_free()</code></a>
</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 2.0</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-quaternion-free"></a><h3>cogl_quaternion_free ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_quaternion_free                (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *quaternion</code></em>);</pre>
<p>
Frees a <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> that was previously allocated via
<a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#cogl-quaternion-copy" title="cogl_quaternion_copy ()"><code class="function">cogl_quaternion_copy()</code></a>.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody><tr>
<td><p><span class="term"><em class="parameter"><code>quaternion</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a>
</td>
</tr></tbody>
</table></div>
<p class="since">Since 2.0</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-quaternion-get-rotation-angle"></a><h3>cogl_quaternion_get_rotation_angle ()</h3>
<pre class="programlisting"><span class="returnvalue">float</span>               cogl_quaternion_get_rotation_angle  (<em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *quaternion</code></em>);</pre>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody><tr>
<td><p><span class="term"><em class="parameter"><code>quaternion</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a>
</td>
</tr></tbody>
</table></div>
<p class="since">Since 2.0</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-quaternion-get-rotation-axis"></a><h3>cogl_quaternion_get_rotation_axis ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_quaternion_get_rotation_axis   (<em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *quaternion</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> *vector3</code></em>);</pre>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>quaternion</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>vector3</code></em> :</span></p></td>
<td>an allocated 3-float array. <span class="annotation">[<acronym title="Parameter for returning results. Default is transfer full."><span class="acronym">out</span></acronym>]</span>
</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 2.0</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-quaternion-normalize"></a><h3>cogl_quaternion_normalize ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_quaternion_normalize           (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *quaternion</code></em>);</pre>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody><tr>
<td><p><span class="term"><em class="parameter"><code>quaternion</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a>
</td>
</tr></tbody>
</table></div>
<p class="since">Since 2.0</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-quaternion-dot-product"></a><h3>cogl_quaternion_dot_product ()</h3>
<pre class="programlisting"><span class="returnvalue">float</span>               cogl_quaternion_dot_product         (<em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *a</code></em>,
                                                         <em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *b</code></em>);</pre>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>a</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>b</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a>
</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 2.0</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-quaternion-invert"></a><h3>cogl_quaternion_invert ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_quaternion_invert              (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *quaternion</code></em>);</pre>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody><tr>
<td><p><span class="term"><em class="parameter"><code>quaternion</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a>
</td>
</tr></tbody>
</table></div>
<p class="since">Since 2.0</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-quaternion-multiply"></a><h3>cogl_quaternion_multiply ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_quaternion_multiply            (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *result</code></em>,
                                                         <em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *left</code></em>,
                                                         <em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *right</code></em>);</pre>
<p>
This combines the rotations of two quaternions into <em class="parameter"><code>result</code></em>. The
operation is not commutative so the order is important because AxB
!= BxA. Cogl follows the standard convention for quaternions here
so the rotations are applied <em class="parameter"><code>right</code></em> to <em class="parameter"><code>left</code></em>. This is similar to the
combining of matrices.
</p>
<p>
</p>
<div class="note" style="margin-left: 0.5in; margin-right: 0.5in;">
<h3 class="title">Note</h3>It is possible to multiply the <em class="parameter"><code>a</code></em> quaternion in-place, so
<em class="parameter"><code>result</code></em> can be equal to <em class="parameter"><code>a</code></em> but can't be equal to <em class="parameter"><code>b</code></em>.</div>
<p>
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>result</code></em> :</span></p></td>
<td>The destination <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>left</code></em> :</span></p></td>
<td>The second <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> rotation to apply</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>right</code></em> :</span></p></td>
<td>The first <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> rotation to apply</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 2.0</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-quaternion-pow"></a><h3>cogl_quaternion_pow ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_quaternion_pow                 (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *quaternion</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> exponent</code></em>);</pre>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>quaternion</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>exponent</code></em> :</span></p></td>
<td>the exponent</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 2.0</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-quaternion-slerp"></a><h3>cogl_quaternion_slerp ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_quaternion_slerp               (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *result</code></em>,
                                                         <em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *a</code></em>,
                                                         <em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *b</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> t</code></em>);</pre>
<p>
Performs a spherical linear interpolation between two quaternions.
</p>
<p>
Noteable properties:
</p>
<div class="itemizedlist"><ul class="itemizedlist" style="list-style-type: disc; ">
<li class="listitem">
commutative: No
</li>
<li class="listitem">
constant velocity: Yes
</li>
<li class="listitem">
torque minimal (travels along the surface of the 4-sphere): Yes
</li>
<li class="listitem">
more expensive than <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#cogl-quaternion-nlerp" title="cogl_quaternion_nlerp ()"><code class="function">cogl_quaternion_nlerp()</code></a>
</li>
</ul></div>
<p>
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>result</code></em> :</span></p></td>
<td>The destination <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>a</code></em> :</span></p></td>
<td>The first <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>b</code></em> :</span></p></td>
<td>The second <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>t</code></em> :</span></p></td>
<td>The factor in the range [0,1] used to interpolate between
quaternion <em class="parameter"><code>a</code></em> and <em class="parameter"><code>b</code></em>.</td>
</tr>
</tbody>
</table></div>
</div>
<hr>
<div class="refsect2">
<a name="cogl-quaternion-nlerp"></a><h3>cogl_quaternion_nlerp ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_quaternion_nlerp               (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *result</code></em>,
                                                         <em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *a</code></em>,
                                                         <em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *b</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> t</code></em>);</pre>
<p>
Performs a normalized linear interpolation between two quaternions.
That is it does a linear interpolation of the quaternion components
and then normalizes the result. This will follow the shortest arc
between the two orientations (just like the <code class="function">slerp()</code> function) but
will not progress at a constant speed. Unlike <code class="function">slerp()</code> nlerp is
commutative which is useful if you are blending animations
together. (I.e. nlerp (tmp, a, b) followed by nlerp (result, tmp,
d) is the same as nlerp (tmp, a, d) followed by nlerp (result, tmp,
b)). Finally nlerp is cheaper than slerp so it can be a good choice
if you don't need the constant speed property of the <code class="function">slerp()</code> function.
</p>
<p>
Notable properties:
</p>
<div class="itemizedlist"><ul class="itemizedlist" style="list-style-type: disc; ">
<li class="listitem">
commutative: Yes
</li>
<li class="listitem">
constant velocity: No
</li>
<li class="listitem">
torque minimal (travels along the surface of the 4-sphere): Yes
</li>
<li class="listitem">
faster than <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#cogl-quaternion-slerp" title="cogl_quaternion_slerp ()"><code class="function">cogl_quaternion_slerp()</code></a>
</li>
</ul></div>
<p>
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>result</code></em> :</span></p></td>
<td>The destination <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>a</code></em> :</span></p></td>
<td>The first <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>b</code></em> :</span></p></td>
<td>The second <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>t</code></em> :</span></p></td>
<td>The factor in the range [0,1] used to interpolate between
quaterion <em class="parameter"><code>a</code></em> and <em class="parameter"><code>b</code></em>.</td>
</tr>
</tbody>
</table></div>
</div>
<hr>
<div class="refsect2">
<a name="cogl-quaternion-squad"></a><h3>cogl_quaternion_squad ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_quaternion_squad               (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *result</code></em>,
                                                         <em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *prev</code></em>,
                                                         <em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *a</code></em>,
                                                         <em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *b</code></em>,
                                                         <em class="parameter"><code>const <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> *next</code></em>,
                                                         <em class="parameter"><code><span class="type">float</span> t</code></em>);</pre>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>result</code></em> :</span></p></td>
<td>The destination <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>prev</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> used before <em class="parameter"><code>a</code></em>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>a</code></em> :</span></p></td>
<td>The first <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>b</code></em> :</span></p></td>
<td>The second <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>next</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="type">CoglQuaternion</span></a> that will be used after <em class="parameter"><code>b</code></em>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>t</code></em> :</span></p></td>
<td>The factor in the range [0,1] used to interpolate between
quaternion <em class="parameter"><code>a</code></em> and <em class="parameter"><code>b</code></em>.</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 2.0</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-get-static-identity-quaternion"></a><h3>cogl_get_static_identity_quaternion ()</h3>
<pre class="programlisting">const <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="returnvalue">CoglQuaternion</span></a> * cogl_get_static_identity_quaternion
                                                        (<em class="parameter"><code><span class="type">void</span></code></em>);</pre>
<p>
Returns a pointer to a singleton quaternion constant describing the
canonical identity [1 (0, 0, 0)] which represents no rotation.
</p>
<p>
If you multiply a quaternion with the identity quaternion you will
get back the same value as the original quaternion.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody><tr>
<td><p><span class="term"><span class="emphasis"><em>Returns</em></span> :</span></p></td>
<td>A pointer to an identity quaternion</td>
</tr></tbody>
</table></div>
<p class="since">Since 2.0</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-get-static-zero-quaternion"></a><h3>cogl_get_static_zero_quaternion ()</h3>
<pre class="programlisting">const <a class="link" href="cogl-2.0-experimental-Quaternions-(Rotations).html#CoglQuaternion" title="CoglQuaternion"><span class="returnvalue">CoglQuaternion</span></a> * cogl_get_static_zero_quaternion  (<em class="parameter"><code><span class="type">void</span></code></em>);</pre>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody><tr>
<td><p><span class="term"><span class="emphasis"><em>Returns</em></span> :</span></p></td>
<td>a pointer to a singleton quaternion constant describing a
rotation of 180 degrees around a degenerate axis:
[0 (0, 0, 0)]</td>
</tr></tbody>
</table></div>
<p class="since">Since 2.0</p>
</div>
</div>
</div>
<div class="footer">
<hr>
          Generated by GTK-Doc V1.18.1</div>
</body>
</html>